<?php
namespace FiloBlu\Flow\Block\Adminhtml\Channel\Edit\Tab;
class Map extends \Magento\Backend\Block\Widget\Form\Generic implements \Magento\Backend\Block\Widget\Tab\TabInterface
{
    /**
     * @var \Magento\Store\Model\System\Store
     */
    protected $_systemStore;

    /**
     * @param \Magento\Backend\Block\Template\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Framework\Data\FormFactory $formFactory
     * @param \Magento\Store\Model\System\Store $systemStore
     * @param array $data
     */

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Data\FormFactory $formFactory,
        \Magento\Store\Model\System\Store $systemStore,
        \FiloBlu\Flow\Helper\Data $helper,
        array $data = array()
    ) {
        $this->_systemStore = $systemStore;
        $this->helper = $helper;
        parent::__construct($context, $registry, $formFactory, $data);
    }
    /**
     * Prepare form
     *
     * @return $this
     */
    protected function _prepareForm()
    {
        /* @var $model \Magento\Cms\Model\Page */
        $model = $this->_coreRegistry->registry('flow_channel');
        $isElementDisabled = false;
        /** @var \Magento\Framework\Data\Form $form */
        $form = $this->_formFactory->create();

        $form->setHtmlIdPrefix('page_');

        $fieldset_map = $form
            ->addFieldset('map_fieldset', array('legend' => __('Map')))
            ->addType(
                'textjson',
                '\FiloBlu\Flow\Block\Adminhtml\Channel\Renderer\Textjson'
            );

//        $fieldset_map->addType('textjson', '\FiloBlu\Flow\Block\Adminhtml\Channel\Renderer\Textjson');

        // TODO : use  switcherConfig to hide map textarea conditionally

        $fieldset_map->addField('use_map', 'select', array(
            'label' => __('Use mapping file'),
            'name' => 'use_map',
            'values' => array('0'=>'No','1'=>'Yes'),
            ));

        $fieldset_map->addField("map", "textjson", array(
            "label" => __("Map JSON"),
            "name" => "map",
            'rows' => 50,
            'cols' => 40
        ));


        $form->setValues($model->getData());
        $this->setForm($form);

        return parent::_prepareForm();
    }

    /**
     * Prepare label for tab
     *
     * @return string
     */
    public function getTabLabel()
    {
        return __('Map');
    }

    /**
     * Prepare title for tab
     *
     * @return string
     */
    public function getTabTitle()
    {
        return __('map');
    }

    /**
     * {@inheritdoc}
     */
    public function canShowTab()
    {
        return true;
    }

    /**
     * {@inheritdoc}
     */
    public function isHidden()
    {
        return false;
    }

    /**
     * Check permission for passed action
     *
     * @param string $resourceId
     * @return bool
     */
    protected function _isAllowedAction($resourceId)
    {
        return $this->_authorization->isAllowed($resourceId);
    }

//    public function getTabUrl()
//    {
//        return $this->getUrl('*/*/edit/', ['_current' => true]);
//    }

}

